# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_lifecycle_py_client.models
from ntnx_lifecycle_py_client.models.OneOflifecycle.v4.svcmgr.ClusterResourceConfigresource_config import ClusterResourceConfigresource_config  # noqa: F401,E501
from ntnx_lifecycle_py_client.models.common.v1.config.KVStringPair import KVStringPair  # noqa: F401,E501

class ClusterResourceConfig(object):

    """

    :param name: (:attr:`name`) Name of resource config.
    :type name: required
     min=1 chars,
    
    :param resource_config: (:attr:`resource_config`) 
    :type resource_config: 
    
    
    :param labels: (:attr:`labels`) Labels for this resource config. Its a key value pair of strings
    :type labels: 
    
    
    :param client: (:attr:`client`) Name of client config to use.
    :type client: 
     min=1 chars,
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'resource_config': 'OneOflifecycle.v4.svcmgr.ClusterResourceConfigresource_config',
        'labels': 'list[common.v1.config.KVStringPair]',
        'client': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'resource_config': 'resourceConfig',
        'labels': 'labels',
        'client': 'client',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, resource_config=None, labels=None, client=None, *args, **kwargs):  # noqa: E501
        self.__name = None
        self.__resource_config = None
        self.__labels = None
        self.__client = None
        self.discriminator = None
        self.__name = name
        if resource_config is not None:
            self.__resource_config = resource_config
        if labels is not None:
            self.__labels = labels
        if client is not None:
            self.__client = client
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lifecycle.v4.svcmgr.ClusterResourceConfig'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def name(self):
        """
        Name of resource config.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def resource_config(self):
        """
        

        :type:
                :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.svcmgr.AhvResourceConfig` | 
                :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.svcmgr.EsxResourceConfig`
        """  # noqa: E501
        return self.__resource_config

    @resource_config.setter
    def resource_config(self, resource_config):

        self.__resource_config = resource_config

    @property
    def labels(self):
        """
        Labels for this resource config. Its a key value pair of strings

        :type:
             list[ :class:`~ntnx_lifecycle_py_client.models.common.v1.config.KVStringPair` ]
        """  # noqa: E501
        return self.__labels

    @labels.setter
    def labels(self, labels):

        self.__labels = labels

    @property
    def client(self):
        """
        Name of client config to use.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__client

    @client.setter
    def client(self, client):
        if client is not None and len(client) < 1:
            raise ValueError("Invalid value for `client`, length must be greater than or equal to `1`")  # noqa: E501

        self.__client = client

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_lifecycle_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ClusterResourceConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClusterResourceConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

