# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class ComponentDetails(object):

    """

    :param messages: (:attr:`messages`) Messages published by the component.
    :type messages: 
    
    
    :param error_message: (:attr:`error_message`) Error details if any.
    :type error_message: 
    
    
    :param timestamp: (:attr:`timestamp`) Time when the health is checked.
    :type timestamp: 
    
    
    :param num_failures: (:attr:`num_failures`) Number of failures since the last success.
    :type num_failures: 
    
    
    :param first_failure_time: (:attr:`first_failure_time`) Time when the first health failure is seen.
    :type first_failure_time: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'messages': 'list[str]',
        'error_message': 'str',
        'timestamp': 'datetime',
        'num_failures': 'int',
        'first_failure_time': 'datetime',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'messages': 'messages',
        'error_message': 'errorMessage',
        'timestamp': 'timestamp',
        'num_failures': 'numFailures',
        'first_failure_time': 'firstFailureTime',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, messages=None, error_message=None, timestamp=None, num_failures=None, first_failure_time=None, *args, **kwargs):  # noqa: E501
        self.__messages = None
        self.__error_message = None
        self.__timestamp = None
        self.__num_failures = None
        self.__first_failure_time = None
        self.discriminator = None
        if messages is not None:
            self.__messages = messages
        if error_message is not None:
            self.__error_message = error_message
        if timestamp is not None:
            self.__timestamp = timestamp
        if num_failures is not None:
            self.__num_failures = num_failures
        if first_failure_time is not None:
            self.__first_failure_time = first_failure_time
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lifecycle.v4.svcmgr.ComponentDetails'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def messages(self):
        """
        Messages published by the component.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__messages

    @messages.setter
    def messages(self, messages):

        self.__messages = messages

    @property
    def error_message(self):
        """
        Error details if any.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__error_message

    @error_message.setter
    def error_message(self, error_message):

        self.__error_message = error_message

    @property
    def timestamp(self):
        """
        Time when the health is checked.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__timestamp

    @timestamp.setter
    def timestamp(self, timestamp):

        self.__timestamp = timestamp

    @property
    def num_failures(self):
        """
        Number of failures since the last success.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_failures

    @num_failures.setter
    def num_failures(self, num_failures):

        self.__num_failures = num_failures

    @property
    def first_failure_time(self):
        """
        Time when the first health failure is seen.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__first_failure_time

    @first_failure_time.setter
    def first_failure_time(self, first_failure_time):

        self.__first_failure_time = first_failure_time

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ComponentDetails, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComponentDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

