# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_lifecycle_py_client.models.lifecycle.v4.svcmgr.Deployment import Deployment  # noqa: F401,E501
from ntnx_lifecycle_py_client.models.lifecycle.v4.svcmgr.Environment import Environment  # noqa: F401,E501

class Info(object):

    """

    :param environment: (:attr:`environment`) 
    :type environment: 
    
    
    :param chart_repository_uri: (:attr:`chart_repository_uri`) 
    :type chart_repository_uri: 
    
    
    :param deployment: (:attr:`deployment`) 
    :type deployment: 
    
    
    :param is_air_gap_enabled: (:attr:`is_air_gap_enabled`) 
    :type is_air_gap_enabled: 
    
    
    :param air_gap_server_uri: (:attr:`air_gap_server_uri`) 
    :type air_gap_server_uri: 
    
    
    :param version: (:attr:`version`) 
    :type version: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'environment': 'lifecycle.v4.svcmgr.Environment',
        'chart_repository_uri': 'str',
        'deployment': 'lifecycle.v4.svcmgr.Deployment',
        'is_air_gap_enabled': 'bool',
        'air_gap_server_uri': 'str',
        'version': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'environment': 'environment',
        'chart_repository_uri': 'chartRepositoryUri',
        'deployment': 'deployment',
        'is_air_gap_enabled': 'isAirGapEnabled',
        'air_gap_server_uri': 'airGapServerUri',
        'version': 'version',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, environment=None, chart_repository_uri=None, deployment=None, is_air_gap_enabled=None, air_gap_server_uri=None, version=None, *args, **kwargs):  # noqa: E501
        self.__environment = None
        self.__chart_repository_uri = None
        self.__deployment = None
        self.__is_air_gap_enabled = None
        self.__air_gap_server_uri = None
        self.__version = None
        self.discriminator = None
        if environment is not None:
            self.__environment = environment
        if chart_repository_uri is not None:
            self.__chart_repository_uri = chart_repository_uri
        if deployment is not None:
            self.__deployment = deployment
        if is_air_gap_enabled is not None:
            self.__is_air_gap_enabled = is_air_gap_enabled
        if air_gap_server_uri is not None:
            self.__air_gap_server_uri = air_gap_server_uri
        if version is not None:
            self.__version = version
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lifecycle.v4.svcmgr.Info'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def environment(self):
        """
        

        :type:
            :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.svcmgr.Environment`
        """  # noqa: E501
        return self.__environment

    @environment.setter
    def environment(self, environment):

        self.__environment = environment

    @property
    def chart_repository_uri(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__chart_repository_uri

    @chart_repository_uri.setter
    def chart_repository_uri(self, chart_repository_uri):
        if chart_repository_uri is not None and not re.search('^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', chart_repository_uri):  # noqa: E501
            raise ValueError(r"Invalid value for `chart_repository_uri`, must be a follow pattern or equal to `/^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__chart_repository_uri = chart_repository_uri

    @property
    def deployment(self):
        """
        

        :type:
            :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.svcmgr.Deployment`
        """  # noqa: E501
        return self.__deployment

    @deployment.setter
    def deployment(self, deployment):

        self.__deployment = deployment

    @property
    def is_air_gap_enabled(self):
        """
        

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_air_gap_enabled

    @is_air_gap_enabled.setter
    def is_air_gap_enabled(self, is_air_gap_enabled):

        self.__is_air_gap_enabled = is_air_gap_enabled

    @property
    def air_gap_server_uri(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__air_gap_server_uri

    @air_gap_server_uri.setter
    def air_gap_server_uri(self, air_gap_server_uri):
        if air_gap_server_uri is not None and not re.search('^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', air_gap_server_uri):  # noqa: E501
            raise ValueError(r"Invalid value for `air_gap_server_uri`, must be a follow pattern or equal to `/^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__air_gap_server_uri = air_gap_server_uri

    @property
    def version(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__version

    @version.setter
    def version(self, version):
        if version is not None and not re.search('^(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)$', version):  # noqa: E501
            raise ValueError(r"Invalid value for `version`, must be a follow pattern or equal to `/^(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)$/`")  # noqa: E501

        self.__version = version

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Info, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Info):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

