# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class LoggingVolumeConfig(object):

    """Configuration of the default volume to be attached to a node for logging purpose.

    :param mount_path: (:attr:`mount_path`) Mount path of the log volume.
    :type mount_path: required
    
    
    :param size_mb: (:attr:`size_mb`) Size of the log volume in MB.
    :type size_mb: required
    
    
    :param storage_config_name: (:attr:`storage_config_name`) Name of the storage config to be used for configuring the log volume.
    :type storage_config_name: required
     min=1 chars, max=64 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'mount_path': 'str',
        'size_mb': 'int',
        'storage_config_name': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'mount_path': 'mountPath',
        'size_mb': 'sizeMb',
        'storage_config_name': 'storageConfigName',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, mount_path=None, size_mb=None, storage_config_name=None, *args, **kwargs):  # noqa: E501
        self.__mount_path = None
        self.__size_mb = None
        self.__storage_config_name = None
        self.discriminator = None
        self.__mount_path = mount_path
        self.__size_mb = size_mb
        self.__storage_config_name = storage_config_name
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lifecycle.v4.svcmgr.LoggingVolumeConfig'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def mount_path(self):
        """
        Mount path of the log volume.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__mount_path

    @mount_path.setter
    def mount_path(self, mount_path):
        if mount_path is None:
            raise ValueError("Invalid value for `mount_path`, must not be `None`")  # noqa: E501

        self.__mount_path = mount_path

    @property
    def size_mb(self):
        """
        Size of the log volume in MB.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__size_mb

    @size_mb.setter
    def size_mb(self, size_mb):
        if size_mb is None:
            raise ValueError("Invalid value for `size_mb`, must not be `None`")  # noqa: E501

        self.__size_mb = size_mb

    @property
    def storage_config_name(self):
        """
        Name of the storage config to be used for configuring the log volume.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__storage_config_name

    @storage_config_name.setter
    def storage_config_name(self, storage_config_name):
        if storage_config_name is None:
            raise ValueError("Invalid value for `storage_config_name`, must not be `None`")  # noqa: E501
        if storage_config_name is not None and len(storage_config_name) > 64:
            raise ValueError("Invalid value for `storage_config_name`, length must be less than or equal to `64`")  # noqa: E501
        if storage_config_name is not None and len(storage_config_name) < 1:
            raise ValueError("Invalid value for `storage_config_name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__storage_config_name = storage_config_name

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(LoggingVolumeConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoggingVolumeConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

