# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class NutanixStorageClass(object):

    """

    :param cluster_ref: (:attr:`cluster_ref`) Nutanix Cluster Reference.
    :type cluster_ref: required
    
    
    :param is_flash_mode: (:attr:`is_flash_mode`) 
    :type is_flash_mode: 
    
    
    :param file_system: (:attr:`file_system`) File system of the storage volume.
    :type file_system: 
    
    
    :param storage_container: (:attr:`storage_container`) Name of the storage container to be used.
    :type storage_container: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_ref': 'str',
        'is_flash_mode': 'bool',
        'file_system': 'str',
        'storage_container': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_ref': 'clusterRef',
        'is_flash_mode': 'isFlashMode',
        'file_system': 'fileSystem',
        'storage_container': 'storageContainer',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_ref=None, is_flash_mode=None, file_system=None, storage_container=None, *args, **kwargs):  # noqa: E501
        self.__cluster_ref = None
        self.__is_flash_mode = None
        self.__file_system = None
        self.__storage_container = None
        self.discriminator = None
        self.__cluster_ref = cluster_ref
        if is_flash_mode is not None:
            self.__is_flash_mode = is_flash_mode
        if file_system is not None:
            self.__file_system = file_system
        if storage_container is not None:
            self.__storage_container = storage_container
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lifecycle.v4.svcmgr.NutanixStorageClass'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def cluster_ref(self):
        """
        Nutanix Cluster Reference.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_ref

    @cluster_ref.setter
    def cluster_ref(self, cluster_ref):
        if cluster_ref is None:
            raise ValueError("Invalid value for `cluster_ref`, must not be `None`")  # noqa: E501
        if cluster_ref is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_ref):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_ref`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_ref = cluster_ref

    @property
    def is_flash_mode(self):
        """
        

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_flash_mode

    @is_flash_mode.setter
    def is_flash_mode(self, is_flash_mode):

        self.__is_flash_mode = is_flash_mode

    @property
    def file_system(self):
        """
        File system of the storage volume.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__file_system

    @file_system.setter
    def file_system(self, file_system):

        self.__file_system = file_system

    @property
    def storage_container(self):
        """
        Name of the storage container to be used.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__storage_container

    @storage_container.setter
    def storage_container(self, storage_container):

        self.__storage_container = storage_container

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NutanixStorageClass, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NutanixStorageClass):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

